/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.EntCosmos;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 * @author obper
 */
@Entity
@Table(name = "wc_grupos_usuarios")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "WcGruposUsuarios.findAll", query = "SELECT w FROM WcGruposUsuarios w")
        , @NamedQuery(name = "WcGruposUsuarios.findByIdGruposUsuarios", query = "SELECT w FROM WcGruposUsuarios w WHERE w.idGruposUsuarios = :idGruposUsuarios")
        , @NamedQuery(name = "WcGruposUsuarios.findByNombreGruposUsuarios", query = "SELECT w FROM WcGruposUsuarios w WHERE w.nombreGruposUsuarios = :nombreGruposUsuarios")
        , @NamedQuery(name = "WcGruposUsuarios.findByAccionGruposUsuarios", query = "SELECT w FROM WcGruposUsuarios w WHERE w.accionGruposUsuarios = :accionGruposUsuarios")})
public class WcGruposUsuarios implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id_grupos_usuarios")
    private Integer idGruposUsuarios;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 45)
    @Column(name = "nombre_grupos_usuarios")
    private String nombreGruposUsuarios;
    @Column(name = "accion_grupos_usuarios")
    private Integer accionGruposUsuarios;
    @Column(name = "tipo_grupos_usuarios")
    private boolean tipoGruposUsuarios;
    @ManyToMany(mappedBy = "wcGruposUsuariosList")
    private List<WcOpciones> wcOpcionesList;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "grupoUsuario")
    private List<WcUsuarios> wcUsuariosList;

    public WcGruposUsuarios() {
    }

    public boolean getTipoGruposUsuarios() {
        return tipoGruposUsuarios;
    }

    public void setTipoGruposUsuarios(boolean tipoGruposUsuarios) {
        this.tipoGruposUsuarios = tipoGruposUsuarios;
    }


    public WcGruposUsuarios(Integer idGruposUsuarios) {
        this.idGruposUsuarios = idGruposUsuarios;
    }

    public WcGruposUsuarios(Integer idGruposUsuarios, String nombreGruposUsuarios) {
        this.idGruposUsuarios = idGruposUsuarios;
        this.nombreGruposUsuarios = nombreGruposUsuarios;
    }

    public Integer getIdGruposUsuarios() {
        return idGruposUsuarios;
    }

    public void setIdGruposUsuarios(Integer idGruposUsuarios) {
        this.idGruposUsuarios = idGruposUsuarios;
    }

    public String getNombreGruposUsuarios() {
        return nombreGruposUsuarios;
    }

    public void setNombreGruposUsuarios(String nombreGruposUsuarios) {
        this.nombreGruposUsuarios = nombreGruposUsuarios;
    }

    public Integer getAccionGruposUsuarios() {
        return accionGruposUsuarios;
    }

    public void setAccionGruposUsuarios(Integer accionGruposUsuarios) {
        this.accionGruposUsuarios = accionGruposUsuarios;
    }

    @XmlTransient
    public List<WcOpciones> getWcOpcionesList() {
        return wcOpcionesList;
    }

    public void setWcOpcionesList(List<WcOpciones> wcOpcionesList) {
        this.wcOpcionesList = wcOpcionesList;
    }

    @XmlTransient
    public List<WcUsuarios> getWcUsuariosList() {
        return wcUsuariosList;
    }

    public void setWcUsuariosList(List<WcUsuarios> wcUsuariosList) {
        this.wcUsuariosList = wcUsuariosList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idGruposUsuarios != null ? idGruposUsuarios.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof WcGruposUsuarios)) {
            return false;
        }
        WcGruposUsuarios other = (WcGruposUsuarios) object;
        if ((this.idGruposUsuarios == null && other.idGruposUsuarios != null) || (this.idGruposUsuarios != null && !this.idGruposUsuarios.equals(other.idGruposUsuarios))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.cosmodas.dbcon.WcGruposUsuarios[ idGruposUsuarios=" + idGruposUsuarios + " ]";
    }

}
